#
# spec file for package python-PsychoPy
#
# Copyright (c) 2016 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           python-PsychoPy
Version:        1.83.03
Release:        2.3
Summary:        Psychophysics toolkit for Python
License:        GPL-3.0+
Group:          Development/Languages/Python
Url:            https://pypi.python.org/pypi/PsychoPy/
Source:         https://github.com/psychopy/psychopy/releases/download/r%{version}/PsychoPy-%{version}.zip
BuildRequires:  fdupes
BuildRequires:  flac
BuildRequires:  python-Pillow
BuildRequires:  python-PySoundCard
BuildRequires:  python-PySoundFile
BuildRequires:  python-PyYAML
BuildRequires:  python-Shapely
BuildRequires:  python-Sphinx
BuildRequires:  python-configobj
BuildRequires:  python-devel
BuildRequires:  python-gevent >= 1.0
BuildRequires:  python-greenlet
BuildRequires:  python-lxml
BuildRequires:  python-matplotlib
BuildRequires:  python-msgpack-python
BuildRequires:  python-numexpr
BuildRequires:  python-numpy-devel
BuildRequires:  python-opencv-qt5
BuildRequires:  python-opengl
BuildRequires:  python-opengl-accelerate
BuildRequires:  python-openpyxl
BuildRequires:  python-pandas
BuildRequires:  python-pp
BuildRequires:  python-psutil >= 1.2
BuildRequires:  python-pyglet
BuildRequires:  python-pyo
BuildRequires:  python-pyserial
BuildRequires:  python-pytest
BuildRequires:  python-pyzmq
BuildRequires:  python-qt4
BuildRequires:  python-scipy
BuildRequires:  python-setuptools
BuildRequires:  python-tables
BuildRequires:  python-tornado
BuildRequires:  python-wxWidgets-3_0
BuildRequires:  python-xlib
BuildRequires:  python-xlrd
BuildRequires:  unzip
%if 0%{?suse_version} >= 1310
BuildRequires:  vlc
%endif
Requires:       IPython
Requires:       python-Pillow
Requires:       python-PySoundCard
Requires:       python-PySoundFile
Requires:       python-Shapely
Requires:       python-configobj
Requires:       python-lxml
Requires:       python-matplotlib
Requires:       python-numpy
Requires:       python-opengl
Requires:       python-openpyxl
Requires:       python-pandas
Requires:       python-pyglet
Requires:       python-pyo
Requires:       python-pyzmq
Requires:       python-qt4
Requires:       python-scipy
Requires:       python-tornado
Requires:       python-wxWidgets-3_0
Recommends:     ffmpeg
Recommends:     flac
Recommends:     python-PyYAML
Recommends:     python-gevent >= 1.0
Recommends:     python-greenlet
Recommends:     python-jupyter_ipython
Recommends:     python-msgpack-python
Recommends:     python-numexpr
Recommends:     python-opencv
Recommends:     python-opengl-accelerate
Recommends:     python-pp
Recommends:     python-psutil >= 1.2
Recommends:     python-pygame
Recommends:     python-pyserial
Recommends:     python-requests
Recommends:     python-rpy2
Recommends:     python-seaborn
Recommends:     python-tables
Recommends:     python-xlib
Recommends:     python-xlrd
Recommends:     vlc
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?suse_version} && 0%{?suse_version} <= 1110
%{!?python_sitelib: %global python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%else
BuildArch:      noarch
%endif

%description
PsychoPy is an open-source application to allow the presentation of
stimuli and collection of data for a wide range of neuroscience,
psychology and psychophysics experiments. It’s a free, powerful
alternative to Presentation™ or e-Prime™, written in Python  (a free
alternative to Matlab™ ).

Note: Due to license issues, the psychopy.visual.movie stimulus cannot be
support by openSUSE directly.  Please use the psychopy.visual.movie2 stimulus
if possible, as it is overall superior and is supported.  If you must use the
psychopy.visual.movie stimulus, you must download avbin manually.  Please
verify that you are able to do so legally in your jurisdiction.
See http://www.psychopy.org/installation.html#dependencies for installation
instructions.

%prep
%setup -q -n PsychoPy-%{version}

%build
python setup.py build

%install
python setup.py install --prefix=%{_prefix} --root=%{buildroot}
mv %{buildroot}%{_bindir}/psychopyApp.py %{buildroot}%{_bindir}/psychopyApp
rm %{buildroot}%{_bindir}/psychopy_post_inst.py

# fix "wrong-script-end-of-line-encoding"
sed -i 's/\r$//' %{buildroot}%{python_sitelib}/psychopy/app/builder/experiment.xsd

# fix "script-without-shebang"
chmod a-x %{buildroot}%{python_sitelib}/psychopy/app/builder/experiment.xsd

# fix "non-executable-script"
chmod a+x %{buildroot}%{python_sitelib}/psychopy/app/psychopyApp.py

# remove shabangs
find %{buildroot}%{python_sitelib}/psychopy/ -name "*.py"|while read lib; do
    sed '1{\@^#!/usr/bin/env python@d}' "$lib" > "$lib.new" &&
    touch -r "$lib" "$lib.new"
    mv -f "$lib.new" "$lib"
done
find %{buildroot}%{python_sitelib}/psychopy/ -name "*.py"|while read lib; do
    sed '1{\@^#! /usr/bin/python@d}' "$lib" > "$lib.new" &&
    touch -r "$lib" "$lib.new"
    mv -f "$lib.new" "$lib"
done

%fdupes -s %{buildroot}
%if 0%{?suse_version} >= 1320
%find_lang messages %{name}.lang --with-python
%else
touch %{name}.lang
%endif

%files -f %{name}.lang
%defattr(-,root,root,-)
%{_bindir}/psychopyApp
%{python_sitelib}/psychopy
%{python_sitelib}/PsychoPy-*-py*.egg-info

%changelog
* Wed Apr 13 2016 toddrme2178@gmail.com
- Recommend python-opencv instead of requiring it.
* Fri Jan  8 2016 toddrme2178@gmail.com
- Update to 1.83.03
  * FIXED: problems with the Mac Standalone failing to launch on
    some OSX versions
  * FIXED: reduced impact of pyglet text memory leaks (make fewer
    updates). (NB There is still a leak in Pyglet’s code
    that we can’t fix)
  * FIXED: several fixes to RatingScale
  * FIXED: window viewScale and viewPos combine correctly;
    viewScale handles negative values, mirror-image flips
    the window correctly (except for Text) #1011
  * FIXED: fixed memory leak in sounds on 64bit Mac installation
    (error in pyo)
  * FIXED: MovieStim3 was interacting badly with ShapeStim #981
  * FIXED: MovieStim3 was failing if no audio stream was present
    in the file #984
  * FIXED: PsychoPy app now gives a warning message if it can’t
    start due to permissions error #1055
  * FIXED: Faster rendering of MovieStim2 and Moviestim3 due to
    removal of mipmapping code
- Note: 1.83.02 never released officially
* Tue Oct 20 2015 toddrme2178@gmail.com
- Update to 1.83.01
  * FIXED: new bug with pygame sounds giving fileName not defined
  * FIXED: several RatingScale bugs; reduce the memory leak
    (due to pyglet as used in TextStim)
  * ADDED: voice-key capability, e.g., for word-naming
    studies; includes a demo, auxillary functions
    (smoothing, zero-crossing, etc), and file-format
    options (all those supported by pyo)
  * CHANGED: remove support for google’s speech to text (the
    new google API is for chrome / chromium developers
    only)
  * CHANGED: deprecate psychopy.web.upload(); use the requests
    package instead: requests.post()
- Update to 1.83.00
  * ADDED: MovieStim3 using an alternative backend that doesn’t
    require avbin, vlc or streamer. It just uses a couple
    of python libs and FFMPEG, which are relatively easy
    to package. Seems to have good performance too but
    this needs more testing
  * IMPROVED: speed to load psychopy.visual (“lazy loading” only
    the stimuli you use are loaded)
  * ADDED: RatingScale precision=60 allows display of time-based
    values (min:sec or hours:min). Values from
    .getRating() are decimal proportions
    (1 min: 59 seconds -> 1.9833 minutes).
  * ADDED: Coder view can now be set to read-only mode to prevent
    subjects accidentally altering study #945
  * ADDED: TextStim now has property boundingBox telling you the
    maximum area of the letters (defined by the font,
    not by the actual rendered letters) #35c168f1
  * ADDED: Aperture can now be created using images (anything
    that worked with ImageStim) #923 and can also be
    inverted so that opaque becomes transparent and vice
    versa #922 Thanks Thomas Emerling for both
  * ADDED: New visual stimulus EnvelopeGrating for
    contrast-modulated gratings. Thanks Andrew Schofield
  * ADDED: option to set mouse_exclusive mode (mouse locked to the
    window boundary and invisible) Thanks Suddha Sourav
    [#898]
  * FIXED: DotStim can now change field size on the fly
  * FIXED: several (but probably not all) annoying error messages
    that were unimportant
  * FIXED: Condition file in Builder no longer abbreviated.
    Thanks Mike #913
* Tue Aug 18 2015 toddrme2178@gmail.com
- Update to 1.82.02
  - FIXED: TrialHandler wasn't saving extraInfo (was overwritten
    during trials)
  - FIXED: don't have pickle file re-saving itself when it comes
    back from pickling
  - FIXED: Mouse Component could crash data saving if no response
    was made
  - FIXED: memory leaks in MovieStim2 (opencv backend)
  - FIXED: checked that window positions are integers
  - FIXED: OSX "10.10" incorrectly looked older than "10.9"
  - FIXED: RatingScale would show "False" for scale description in
    some cases
  - FIXED: problem with microphone saving files that end with
    w, a or v
  - FIXED: MonitorCenter failing to create new monitor
  - FIXED: universal line endings in csv outputs files
  - FIXED: unicode in conditions files
  - FIXED: `iohub` not detecting Linux mouse events
  - FIXED: if output file is set to be `stdout` this should then
    be closed
  - FIXED: don't abbreviate the path name of conditions files
  - FIXED: minor error in logging for `rush()` under win32
  - FIXED: unicode issues in user preferences panel
  - FIXED: MonitorCenter won't lock you out if given an invalid
    screen number
  - FIXED: mono++ mode in CRS Bits++/#/Display++ is now using full
    dynamic range (previously 8bit blue gun overlay was
    overriding the 16bit screen buffer)
* Thu May 21 2015 toddrme2178@gmail.com
- Fix included files
* Mon Mar  2 2015 toddrme2178@gmail.com
- Update to 1.82.01
  * FIXED: problem with MovieStim2 showing black box instead of
    movie on certain systems
  * FIXED: problem with Tobii eye tracker not closing calibration
    window (Sol)
  * FIXED: better timing for non-slip routines that follow dynamic
    routines (Jeremy) #822
  * FIXED: problem with stimuli (e.g. shapes) not appearing if a
    texture had just been created and not yet drawn
  * FIXED: pygame sound engine complained about “global variable
    loops not defined”
  * ENHANCED: Filename collision handling for ExperimentHandler
    (Richard Höchenberger)
  * CHANGED: for text data outputs that give delim=’t’ the file
    extension ‘.tsv’ is added instead of ‘.dlm’
    (Richard Höchenberger)
- Update to 1.82.00
  * ADDED: improved support for Cambridge Research Systems
    Display++ and Bits# devices:
  - Color++ and Mono++ modes now supported using shaders
  - fixed some bugs with search for identityLUT in Display++
  * ADDED: Psi adaptive staircase method (thanks Joseph Glavan
    for writing this)
  * ADDED: bidi and xlwt packages to the Standalone distribution
  * ADDED: support for Mouse.setPos() under pyglet back end
    (Jeremy)
  * ADDED: support for PST response box (Richard Höchenberger)
  * ADDED: Builder now supports ‘degFlat and ‘degFlatPos’ units
    and documentation has been added for these
  * ENHANCED: slightly faster rendering of movies for high-rate
    HD stimuli
  * CHANGED: pandas is now a strict requirement for the
    psychopy.data module
  * FIXED: Builder sounds from file no longer loop indefinitely
  * FIXED: Builder: microphone recordings are explicitly stopped
    at the end of every trial
  * FIXED: Static Components could become hidden by having
    unknown durations and then couldn’t be changed.
    Now they are always shown even when times are unknown
    (Jeremy)
  * FIXED: extraInfo was not being saved in wide-text format
  * FIXED: Builder was not respecting order for drawing
    polygon - it was always drawn first
* Tue Jan 13 2015 toddrme2178@gmail.com
- Update to 1.81.03
  * ADDED: Sounds in Builder can now have a duration set by a
    variable (changing each repeat). The work on this may
    cause some systems to have a periodic 'tick' in the
    sound if they last longer than 10s (probably dependent
    on sound card and driver)
  * IMPROVED: RatingScale will always display a custom description
    ('scale') if provided by the user
  * ADDED: Monitor Center can now calibrate non-primary monitors
  * FIXED: components in Builder can now be 'stopped' at the same
    time as they are started and never show up (previously at
    least one frame was always required)
  * FIXED: several issues with Bits++ causing a rendering glitch and
    not being able to calibrate from Monitor Centre
  * FIXED: choice selection boxes stopped working in monitor centre
    (caused by hardware.crs.bits importing pyglet.gl)
  * FIXED: Bits# can be set to do gamma correction in the PsychoPy
    LUT ('software') rather than using the on-board gamma table
    file ('hardware')
  * FIXED: bug with monitor calib files not returning their
    linearization method correctly
  * ADDED: psychopy.qtgui as alternative to gui which doesn't duffer
    from problem with choice boxes and pyglet clashing
    (thanks Sol)
  * FIXED: data files now correctly include the originPath (the path
    to the script that created them). Thanks Alex Holcombe for
    the fix
- Update copyright year to 2015
* Thu Nov 20 2014 toddrme2178@gmail.com
- Fix building on earlier versions of openSUSE.
* Wed Nov 19 2014 toddrme2178@gmail.com
- Initial version
